// --- [ dcf_77.h ] -----------------------------------------------------------
//       26.03.10 - reduzierte Version 
//       tab = 3
//
// ----------------------------------------------------------------------------

// --- Konstanten -------------------------------------------------------------

#define MS_100			9						// Counts fr 0.1 Sek Puls [Einheit 0.01sec]
#define MS_200			19						// Counts fr 0.2 Sek Puls
#define MS_1000		99						// Counts fr 1.0 Sek Puls
#define MS_2000		199					// Counts fr 2.0 Sek Puls
#define TOL1			3						// zulssige Zeitabweichung +- des DCF-Signals (bei 0.1/0.2 Sekunden)
#define TOL2			7						// zulssige Zeitabweichung +- des DCF-Signals (bei 1/2 Sekunden)

													// Bitpositionen fr flag
#define SYNCH_ENABLE 0						// zeigt dan, dass eine Synchronisation mit der DCF-Zeit gefordert ist
#define XTL_SEC		1						// neue Sekunde ist angebrochen
#define DCF_RX_58		2						// 58 DCF-Bits empfangen
#define XTL_MINUTE	3						// neue Minute der internen xtal-Uhr erreicht
#define DCF_MINUTE	4						// neue Minute aus DCF-Signal empfangen
#define DISPLAY		5						// die Anzeige muss aktualisiert werden
#define SYNCH			6						// Die Zeit wurde neu auf die DCF-Zeit synchronisiert
#define START_FLAG	7						// Signalisiert den Programmstart, bentigt zur bernahme der 1. Minute

#define ERR_PARITY	0						// Parittsfehler
#define ERR_BIT_CNT	1						// nicht genau 58 Bit empfangen
#define ERR_SIGNAL	2						// DCF_Signal-Fehler (Counter berlauf)
#define ERR_NO_DCF	3						// Signalabstand grer als 2 Sekunden
#define ERR_TWI   	7						// Die Uhrzeit wurde zum Debuggen via TWI gendert

// --- Prototypen -------------------------------------------------------------

void SUN_display(void);
void TWI_SLA_Initialise(void);

void DCF_decode(void);
uint8_t calc_time(uint8_t i, uint8_t cnt);
uint8_t calc_parity(uint8_t i, uint8_t cnt);
void DCF_decr_time(uint8_t *time, uint8_t minute);
void DCF_incr_time(uint8_t *time, uint8_t minute);
void DCF_copy_time(uint8_t *target, uint8_t *source);
void DCF_make_UTC_time(void);
uint8_t DCF_compare_time(uint8_t *time1, uint8_t *time2);
void DCF_backup(void);
uint8_t DCF_time_valid(void);

void print_dcfbits(void);
void print_datum(void);

uint8_t is_leap(uint8_t j);
uint16_t day_of_year(uint8_t *time);
void switch_summertime(uint8_t *time);
uint8_t is_summertime(uint8_t *time);
void set_summertime(uint8_t *time, uint8_t i);
void display_second(void);
void display_time(uint8_t *time);
void zeit_zeichen(void);

#ifdef LOG_RS232
void print_datum(void);
void print_dcfbits(void);
#endif

// --- [ eof ] ----------------------------------------------------------------