// --- [ global.h ] -----------------------------------------------------------
//       26.03.10 - reduzierte Version
//       tab = 3
//
// ----------------------------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

#define M168									// Register fr den ATMEGA168
//#define M8
#define WATCHDOG
//#define LOG_RS232							// Eine Log-Datei auf RS232 ausgeben - kostet ca. 1300 Byte

#define LCD										// ohne LCD Ausgaben ist der Code 1250 Byte krzer
#define DEBUG									// lsst den Fehlercounter im LCD stehen, sofern > 0
													// und zeigt auch Ankndigungsbits des DCF-Signals an
//#define SHOW_ERRORS						// Zeigt die ber einen Tag kummulierte Anzahl von Fehlern
													// sowie die DCF-Zusatzsbits (sofern ausser Z1/Z2 Bits gesetzt waren)
													// zeigt an, ob nach dem DCF-Signal oder dem XTAL synchronisiert wird
#define TWI_ADR_CHANGE						// Erlaubt, die TWI-Adresse von aussen zu ndern und
													// dauerhaft im eeprom zu speichern -> dann MUSS EEPROM_START > 1 sein !
#define EEPROM_START	8						// die ersten 8 Byte im Eeprom sind fr die TWI-Adresse freigehalten
#define TIMEBYTES		8						// Anzahl der Bytes in jedem Schalt/timearray
													// Index auf das Array time[x][8]
#define CLK				0						// die fr die Anzeige massgebliche Zeit der Uhr (+ 1Byte Sekunde)
#define DCF				1						// die Zeit des DCF-Signals
#define UTC   			2						// die Zeit fr Lngengrad 0, cet - 1h, cest - 2h
#define BK2				3						// eine Kopie der vorletzten Minute
#define CMP				4						// die um 1 Minute incremenierte Zeit fr Plausibiltsprfung
#define BAK				5						// eine Kopie der letzten Minute fr Plausibilittsprfung
#define BK1				5
#define CLK_ARRAYS	6						// die Anzahl der Arrays von CLK bis BAK

#define LAST_STATE	0						// Index fr schalter / letzte Schalterstellung
#define NEW_STATE		1						// Index fr schalter / neue   Schalterstellung

EXTERN uint8_t time[CLK_ARRAYS][TIMEBYTES];// aktuelle Zeit (7 Arrays)
EXTERN uint16_t day_of_year(uint8_t *time);
EXTERN char msg[4];							// fr die Umwandlung von Zahlen in Ziffernfolge


#define MINUTE			0						// Index fr alle Zeitarrays
#define STUNDE 		1
#define DOW				2
#define TAG				3						// Wochentag (Bit.0 ... Bit.6) + Sommerzeit !! (= Bit.7)
#define MONAT			4
#define JAHR   		5
													// jeweils das 7./8. Element in den Arrays:
#define SEKUNDE		6						// time[CLK][x] - die aktuelle Sekunde
#define ZBITS			6						// time[DCF][x] - die Zusatzbits des DCF-Signal
#define SWITCH       6						// time[schalter][x] - Schalternr
#define MODUS			7						// time[schalter][x] - der Schaltmodus in den Schaltdefinitionen

#define TRUE			1
#define FALSE			0

#define SYNCH_TIME	29						// Die Anzahl der Minuten, die die Uhr ohne Synchronisation mit dem DCF-Signal
													// nur nach dem XTL-Takt luft

// --- [ eof ] ----------------------------------------------------------------