// --- [ rs232.c ] ------------------------------------------------------------

#include <avr/io.h>
#include <avr/pgmspace.h> 
#include <avr/interrupt.h>
#include <stdlib.h>
//#include <string.h>

#include "global.h" 
#include "rs232.h"
#include "dcf_bits.h"
#include "dcf_77.h"

#ifdef LOG_RS232
// ----------------------------------------------------------------------------
// Setzt die Baudrate
// der bergebene Parameter entspricht dem Wert von UBBRL

void rs232_init(uint8_t baud)
{
//UBRRL = baud;
UBRR0L = baud;		
//UBRRH = 0;
//UCSRB = (0<<RXCIE | 0<<RXEN | 1<<TXEN);
UCSR0B = (0<<RXCIE0 | 0<<RXEN0 | 1<<TXEN0);
//UCSRC = (1<<URSEL | 0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
UCSR0C = (1<<UCSZ01) | (1<<UCSZ00);
// URSEL - Achtung bei ATmega 8
//UCSRC |= (0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
}


// ----------------------------------------------------------------------------
// ein einzelnes Zeichen auf COM ausgeben
void put_c(uint8_t Zeichen)
{
//while(!(UCSRA & (1<<UDRE)));
while(!(UCSR0A & (1<<UDRE0)));
//UDR = Zeichen;
UDR0 = Zeichen;
}

// ----------------------------------------------------------------------------
// einen String auf COM ausgeben
void put_s(char *s)
{
while(*s)
	{
	put_c(*s);
	s++;
	}
}

#endif
// --- [ eof ] ----------------------------------------------------------------